{ lib, stdenv, fetchFromGitHub, cmake } :

stdenv.mkDerivation rec {
  pname = "hpcg";
  version = "114602d";

  src = fetchFromGitHub {
    owner = "hpcg-benchmark";
    repo = pname;
    rev = "114602d458d1034faa52b71e4c15aba9b3a17698";
    hash = "sha256-n+Qz0G630SyG3v1E1buwjHO8t779tq2TbWBcAjwwvxw=";
  };

  nativeBuildInputs = [ cmake ];
  enableParallelBuilding = true;

  installPhase = ''
    mkdir -p $out/bin $out/share/hpcg

    cp xhpcg $out/bin
    #cp hpcg.dat $out/share/hpcg
  '';

  meta = with lib; {
    description = "HPC conjugate gradient benchmark";
    homepage = "https://www.hpcg-benchmark.org";
    platforms = platforms.linux;
    license = licenses.bsd3;
    maintainers = [ maintainers.markuskowa ];
  };
}

